package com.dsic.gj_erp.service.pgd.impl;

import cn.hutool.core.date.DateUtil;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.dsic.gj_erp.bean.jhgk.DmYdjhLj;
import com.dsic.gj_erp.bean.pgd.PgdPkjh;
import com.dsic.gj_erp.mapper.pgd.PgdPkjhMapper;
import com.dsic.gj_erp.service.jhgk.DmYdjhLjService;
import com.dsic.gj_erp.service.pgd.PgdPkjhService;
import com.dsic.gj_erp.service.sy.SYService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@Service
public class PgdPkjhServiceImpl extends ServiceImpl<PgdPkjhMapper, PgdPkjh> implements PgdPkjhService {

    @Autowired
    DmYdjhLjService dmYdjhLjService;

    @Autowired
    SYService syService;

    @Override
    public void savePkPgdJs(List<DmYdjhLj> pkjhs, HttpServletRequest request) {
        List<DmYdjhLj>ups= new ArrayList<>();
        pkjhs.forEach(f->{
            DmYdjhLj e= new DmYdjhLj();
            e.setPjsry((String) request.getAttribute("yhms"));
            e.setPjsrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setPkZt("03");
            e.setId(f.getId());
            ups.add(e);
        });
        dmYdjhLjService.updateBatchById(ups);
    }

    @Override
    public void savePkPgdXd(List<DmYdjhLj> pkjhs, HttpServletRequest request) {
        List<DmYdjhLj>ups= new ArrayList<>();
        pkjhs.forEach(f->{
            DmYdjhLj e= new DmYdjhLj();
            e.setPkXfry((String) request.getAttribute("yhms"));
            e.setPkXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setPscdw(f.getPscdw());
            e.setPscry(f.getPscry());
            e.setPkZt("02");
            e.setPkbs("Y");
            e.setPkjhrq(f.getPkjhrq());
            e.setId(f.getId());
            if(StringUtils.isBlank(f.getPgdh())){
                String id = syService.f_getpjh("MM", "00", "LJLJ");
                e.setPgdh(id);
            }
            ups.add(e);
        });
        dmYdjhLjService.updateBatchById(ups);
    }

    @Override
    public void savePkPgdFk(List<DmYdjhLj> pkjhs, HttpServletRequest request) {
        List<DmYdjhLj>ups= new ArrayList<>();
        pkjhs.forEach(f->{
            DmYdjhLj e= new DmYdjhLj();
            e.setPkFkry((String) request.getAttribute("yhms"));
            e.setPkFkrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setPkZt("03");
            e.setPkFkyy(f.getPkFkyy());
            e.setId(f.getId());
            ups.add(e);
        });
        dmYdjhLjService.updateBatchById(ups);
    }

    @Override
    public void savePkFk(List<DmYdjhLj> pkjhs, HttpServletRequest request) {

        List<DmYdjhLj>ups= new ArrayList<>();
        pkjhs.forEach(f->{
            DmYdjhLj e= new DmYdjhLj();
           e.setPkry(e.getPkry());
           e.setPkksrq(e.getPkksrq());
           e.setPkjsrq(e.getPkjsrq());
            e.setId(f.getId());
            ups.add(e);
        });
        dmYdjhLjService.updateBatchById(ups);
    }

    @Override
    public void savePkPgdXdBack(List<DmYdjhLj> pkjhs, HttpServletRequest request) {
        List<DmYdjhLj>ups= new ArrayList<>();
        pkjhs.forEach(f->{
            DmYdjhLj e= new DmYdjhLj();
            e.setPkXfry((String) request.getAttribute("yhms"));
            e.setPkXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            if(f.getPkZt().equals("02")){
                e.setPkZt("01");
            }
            e.setId(f.getId());
            ups.add(e);
        });
        dmYdjhLjService.updateBatchById(ups);
    }
}
